# Evoluted PHP coding standard

Because we all have standards.

## Quick start

* Grab the latest version of [PHP-CS](https://github.com/squizlabs/PHP_CodeSniffer)
* Add this repo to your project: `composer require --dev evoluted/coding-standard:version` - always lock to a version
* Add a `phpcs.xml.dist` file to the root of your project, make it look like [`phpcs-sample.xml`](phpcs-sample.xml)
* Run `phpcs <your source directory>`

## About

[PSR-2 coding standards](https://github.com/php-fig/fig-standards/blob/master/accepted/PSR-2-coding-style-guide.md) are a great starting point for standards but are, by their nature, very broad.

**[Very broad](examples/BadPsr2.php)**

The Evoluted PHP coding standard builds on PSR-12 with a series of standards aimed at making all of the code we produce similarly styled. This means that when it comes to code reviews or bug fixes you can focus on what the code does, and not about how the code looks.

## Details

The Evoluted coding standards are:

* Built on top of PSR-12
* Designed to reduce the dissonance when switching projects
* For new and modern projects only - Cake has its own *particular* style
* Built upon consensus and best practice
* Runnable from the PHP-CS command line tool
* Versioned
* Always evolving

## Current standards

* [PSR-2](https://www.php-fig.org/psr/psr-2/)
* [PSR-12](https://www.php-fig.org/psr/psr-12/)
* [Slevomat coding style](https://github.com/slevomat/coding-standard)

